Package net.sf.saxon.event

## Class NamespaceDifferencer

- java.lang.Object
- - net.sf.saxon.event.SequenceReceiver
  - - net.sf.saxon.event.ProxyReceiver
    - - net.sf.saxon.event.NamespaceDifferencer

- All Implemented Interfaces:
    `javax.xml.transform.Result`, `Receiver`

      public class NamespaceDifferencer
      extends ProxyReceiver

  `NamespaceDifferencer` is a `ProxyReceiver` responsible for removing duplicate namespace declarations. It also ensures that namespace undeclarations are emitted when necessary.

  The NamespaceDifferencer assumes that in the input event stream, all in-scope namespaces for every element are accounted for in the call on namespace(). In the output event stream, the namespace() call represents namespace declarations rather than in-scope namespaces. So (a) redundant namespaces are removed, and (b) namespace undeclarations are added where necessary. A namespace undeclaration for the default namespace is always added if the parent element has a default namespace and the child element does not; namespace undeclarations for other namespaces are emitted only when the serialization option undeclare-namespaces is set.

  The `NamespaceDifferencer` is part of the serialization pipeline, responsible for translating result trees to serialized XML. As such, it is not concerned with operations such as namespace fixup and namespace inheritance that are part of the result tree construction process.

  The `NamespaceDifferencer` is also needed when writing output to tree models such as DOM and JDOM that require local namespace declarations to be provided for each element node.

- - ### Field Summary

    - ### Fields inherited from class net.sf.saxon.event.ProxyReceiver

      `nextReceiver`

    - ### Fields inherited from class net.sf.saxon.event.SequenceReceiver

      `pipelineConfiguration, previousAtomic, systemId`

    - ### Fields inherited from interface javax.xml.transform.Result

      `PI_DISABLE_OUTPUT_ESCAPING, PI_ENABLE_OUTPUT_ESCAPING`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `NamespaceDifferencer​(Receiver next, java.util.Properties details)` | Create a NamespaceDeclarer

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `endElement()` | End of element
    `void` | `startElement​(NodeName elemName, SchemaType type, AttributeMap attributes, NamespaceMap namespaces, Location location, int properties)` | startElement.

    - ### Methods inherited from class net.sf.saxon.event.ProxyReceiver

      `append, characters, close, comment, endDocument, getNamePool, getNextReceiver, open, processingInstruction, setPipelineConfiguration, setSystemId, setUnderlyingReceiver, setUnparsedEntity, startDocument, usesTypeAnnotations`

    - ### Methods inherited from class net.sf.saxon.event.SequenceReceiver

      `append, decompose, flatten, getConfiguration, getErrorCodeForDecomposingFunctionItems, getPipelineConfiguration, getSystemId, handlesAppend`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### NamespaceDifferencer

          public NamespaceDifferencer​(Receiver next,
                                      java.util.Properties details)

      Create a NamespaceDeclarer
      Parameters:
        `next` - the Receiver to which events will be passed after namespace reduction

  - ### Method Detail

    - #### startElement

          public void startElement​(NodeName elemName,
                                   SchemaType type,
                                   AttributeMap attributes,
                                   NamespaceMap namespaces,
                                   Location location,
                                   int properties)
                            throws XPathException

      startElement. This call removes redundant namespace declarations, and possibly adds an xmlns="" undeclaration.
      Specified by:
        `startElement` in interface `Receiver`
      Overrides:
        `startElement` in class `ProxyReceiver`
      Parameters:
        `elemName` - the name of the element.
        `type` - the type annotation of the element.
        `attributes` - the attributes of this element
        `namespaces` - the in-scope namespaces of this element: generally this is all the in-scope namespaces, without relying on inheriting namespaces from parent elements
        `location` - an object providing information about the module, line, and column where the node originated
        `properties` - bit-significant properties of the element node. If there are no relevant properties, zero is supplied. The definitions of the bits are in class `ReceiverOption`
      Throws:
        `XPathException` - if an error occurs

    - #### endElement

          public void endElement()
                          throws XPathException

      Description copied from class: `ProxyReceiver`
      End of element
      Specified by:
        `endElement` in interface `Receiver`
      Overrides:
        `endElement` in class `ProxyReceiver`
      Throws:
        `XPathException` - if an error occurs